import os,sys
import numpy as np

# seed the pseudorandom number generator
from numpy.random import seed
from numpy.random import rand

N = 7
Nsq2 = 2*N*N

# Load spectro and WL+GCph+XC
FISH_GCsp = np.loadtxt('Fisher_GCsp_flat.txt')
FISH_XC = np.loadtxt('Fisher_XC_GCph_WL_flat.txt')

# Marginalizing over uncommon parameters between the two matrices
COV_GCsp_first = np.linalg.inv(FISH_GCsp)
COV_XC_first = np.linalg.inv(FISH_XC)
COV_GCsp = COV_GCsp_first[0:N,0:N]
COV_XC = COV_XC_first[0:N,0:N]
# Invert to get Fisher matrix
FISH_sp = np.linalg.inv(COV_GCsp)
FISH_xc = np.linalg.inv(COV_XC)

# Search for common build eigen vectors between FISH_sp and FISH_xc
D1,V1 = np.linalg.eig(FISH_sp)
D2,V2 = np.linalg.eig(FISH_xc)

# Loop to generate a basis of common eigen vectors
V = np.zeros((7,7))
D = np.zeros((7,7))

# seed random number generator : based on current system time
seed(None)
# generate some random numbers
coef = rand(2)
C = coef[0]*FISH_sp + coef[1]*FISH_xc
D, V = np.linalg.eig(C)

# Check if we get diagonal matrix
eigen_final = np.diag(coef[0]*D1 + coef[1]*D2)
#eigen_final = D

# Final sum
FISH_final = np.dot(np.dot(V,eigen_final),np.linalg.inv(V))

# Save Fisher_final
np.savetxt('Fisher_final.txt',FISH_final)

# Print constraints and FoM
status = os.system('./printFoM_and_Constraints_from_FisherTotallySAF Fisher_final.txt OPT GCph 0 0 F N')

